<?php

namespace Drupal\drupalmoduleupgrader;

use Drupal\Core\Plugin\PluginBase;

/**
 * Base class for analyzers.
 */
abstract class AnalyzerBase extends PluginBase implements AnalyzerInterface {

  /**
   * Creates an issue with title, summary, and documentation pulled from the
   * plugin definition.
   *
   * @param TargetInterface $target
   *  The target module.
   *
   * @return IssueInterface
   */
  protected function buildIssue(TargetInterface $target) {
    $issue = new Issue($target, $this->pluginDefinition['message'], $this->pluginDefinition['summary']);

    foreach ($this->pluginDefinition['documentation'] as $doc) {
      $issue->addDocumentation($doc['url'], $doc['title']);
    }

    return $issue
      ->setTag('error_level', AnalyzerInterface::ERROR)
      ->setTag('category', $this->t('Miscellaneous'));
  }

}
