<?php

namespace Drupal\Tests\drupalmoduleupgrader\Unit\Plugin\DMU\Converter\Functions;

use Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions\DB;
use Pharborist\Parser;

/**
 * @group DMU.Converter.Functions
 * @covers \Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions\DB
 *
 * Currently, the DB plugin behaves identically for every function it handles,
 * so I'm only bothering to test db_select().
 */
class DBTest extends FunctionCallModifierTest {

  public function testRewriteDBSelectAllowedTable() {
    $plugin = new DB([], '_db:db_select', ['function' => 'db_select']);
    $function_call = Parser::parseExpression('db_select("session")');
    $this->assertSame($function_call, $plugin->rewrite($function_call, $this->target));
  }

  public function testRewriteDBSelectForbiddenTable() {
    $plugin = new DB([], '_db:db_select', ['function' => 'db_select']);
    $function_call = Parser::parseExpression('db_select("variable")');
    $this->assertNull($plugin->rewrite($function_call, $this->target));
  }

}
