<?php

namespace Drupal\Tests\drupalmoduleupgrader\Unit\Plugin\DMU\Converter\Functions;

use Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions\Theme;
use Pharborist\Parser;

/**
 * @group DMU.Converter.Functions
 * @covers \Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions\Theme
 */
class ThemeTest extends FunctionCallModifierTest {

  public function setUp() {
    parent::setUp();
    $this->plugin = new Theme([], 'theme', []);
  }

  public function testRewrite() {
    $function_call = Parser::parseExpression('theme("foo", [])');
    $rewritten = $this->plugin->rewrite($function_call, $this->target);
    $this->assertSame($rewritten, $function_call);
    $this->assertEquals('_theme("foo", [])', $rewritten->getText());
  }

}
